{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X+ }

{$IFDEF DEBUG }
  {$R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

{$M $4000,0,655360 }

{
 ==== TJ 2003 ===
  Il faut definir "ToScreen" pour que la compilation fonctionne
 =================
}

Program CAPTEL;

Uses Dos, Crt, Video2, XSer, StrTools, VdtDisp, Colors, EmulM2, Telix;

Const
      INTVIDEO    = $10;

      VMODE_UNDEF = 0;
      VMODE_MDA   = 1;
      VMODE_CGA   = 2;

      ComUART   : Word = 0; { doit tre dfini par configuration }
      ComIRQ    : Byte = 0;
      ComIn     : Word = 8192;
      ComOut    : Word = 8192;
      VideoMode : Byte = VMODE_UNDEF;
      NeedHelp  : Boolean = FALSE;

      ComSlow   : Boolean = FALSE;
      ComSilence: Boolean = FALSE;

      EmulDRCS  : Boolean = TRUE;
      EmulRTIC  : Boolean = TRUE;
      EmulInsLow: Boolean = FALSE;
      EmulC15Clr: Boolean = FALSE;
      EmulAuto  : Boolean = TRUE;

      LPTNum    : Word = 1;      { lors de la configuration seulement }


Var   Em        : EmulRec;
      AffMdPage : Boolean;
      GenPause  : Boolean;
      LPTStr    : String[1];
      SaveStr   : String;
      TelixRun  : Boolean;
      TelixStr  : String;


{$I CAPCOM.PAS }

{$I CONFIG.PAS }

Procedure CurOFF; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    MOV  AH, 01h
    AND  CH, 10011111b    { bit 5-6  00 }
    OR   CH, 00100000b    { bit 5-6 = 01 => invisible }
    INT  INTVIDEO
End;


Procedure CurON; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    MOV  AH, 01h
    AND  CH, 10011111b    { bit 5-6  00 }
    INT  INTVIDEO
End;



Procedure CurSmall; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    AND  CH, 11100000b    { garder bit5  7 }
    AND  CL, 11100000b
    CMP  [VideoMode], VMODE_MDA
    JNE  @ICI
    OR   CH, 11           { ligne de debut }
    OR   CL, 12           { ligne fin }
    JMP  @SETCUR
@ICI:
    OR   CH, 6            { ligne de debut }
    OR   CL, 7            { ligne fin }
@SETCUR:
    MOV  AH, 01h
    INT  INTVIDEO
End;


Procedure CurBig; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    AND  CH, 11100000b    { garder bit5  7 }
    AND  CL, 11100000b
    CMP  [VideoMode], VMODE_MDA
    JNE  @ICI
    OR   CH, 0            { ligne de debut }
    OR   CL, 13           { ligne fin }
    JMP  @SETCUR
@ICI:
    OR   CH, 0            { ligne de debut }
    OR   CL, 7            { ligne fin }
@SETCUR:
    MOV  AH, 01h
    INT  INTVIDEO
End;



Procedure CurPos( column, row : Byte ); Assembler;
Asm
    MOV  AH, 02h
    MOV  DL, column
    MOV  DH, row
    XOR  BH, BH
    INT  INTVIDEO
End;


Procedure VideoInit;
Var Reg : Registers;
Begin
 If VideoMode=VMODE_UNDEF Then
  Begin
   Intr($11,Reg);
   If Reg.AX And 48=48 Then VideoMode := VMODE_MDA
   Else VideoMode := VMODE_CGA;
  End;

 OpenVideoSys(VideoMode,FALSE);  { Couleur }
End;


Procedure VideoDone;
Begin
 CloseVideoSys;
End;



procedure Tronque(var texte : string; max : byte);
begin
  if byte(texte[0])>max then texte[0] := char(max);
end;

function FillString(long: word; data : byte) : string;
var buf : string;
begin
  FillChar(buf[1],long,data);
  buf[0] := char(long);
  FillString := buf;
end;

function CentralPos(longtexte,long : byte):byte;
begin
  CentralPos := ((long-Longtexte) shr 1)+1;
end;

function CentreString(texte : string; long,data : byte) : string;
var buf   : string;
begin
  buf := FillString(long,data);
  Tronque(texte,long);
  move(texte[1],buf[CentralPos(byte(texte[0]),long)],word(texte[0]));
  CentreString := buf;
end;


Function  GetKey( Var Key : Char; Var Funct : Boolean ) : Boolean;
Var k : Char;
    f : Boolean;
Begin
 If BreakDetect Then
  Begin
   Key   := #$FF;   { BREAK !!! }
   Funct := TRUE;
   BreakDetect := FALSE;
  End
 Else
  If KeyPressed Then
   Begin
    k := ReadKey;
    f := k=#0;
    If f Then k := ReadKey;
    Key := k;
    Funct := f;
    GetKey := TRUE;
   End
  Else GetKey := FALSE;
End;


Function  KeyAbort : Boolean;
Var k : Char;
    f : Boolean;
Begin
 KeyAbort := GetKey(k,f) And (Not(f) And ((k=#27) or (UpCase(k)='A')));
End;


Procedure Beep;
Begin
 Sound(800);
 Delay(250);
 NoSound;
End;



Type ARResult = (AR_NIL, AR_Reprise, AR_Abandon, AR_Continuer );

Function AbandonOuReprise( Titre, Texte1, Texte2 : String;
                           EtContinuer : Boolean ) : ARResult;
Const X = 18; Y = 8; Lg=44; Ht=7;
Var Res : ARResult;
    k   : Char;
    f   : Boolean;
Begin
 PushZc(X,Y,Lg,Ht);

 ClrZc(X,Y,Lg,Ht,CRien);
 CdrZc(X,Y,Lg,Ht, CdrTab[2], CRien );
 WrtScr(Titre,X+CentralPos(Length(Titre),Lg-2),Y,CRien);

 WrtScr(CentreString(Texte1,Lg-2,32),X+1,Y+2,CTout);
 WrtScr(CentreString(Texte2,Lg-2,32),X+1,Y+3,CTout);
 If EtContinuer Then
  Begin
   WrtScr('Abandon   Reprise   Continuer',X+12-5,Y+5,CRien);
   WrtScr('A',X+12-5,Y+5,CRvs);
   WrtScr('R',X+12-5+10,Y+5,CRvs);
   WrtScr('C',X+12-5+10+10,Y+5,CRvs);
  End
 Else
  Begin
   WrtScr('Abandon  ou  Reprise',X+12,Y+5,CRien);
   WrtScr('A',X+12,Y+5,CRvs);
   WrtScr('R',X+25,Y+5,CRvs);
  End;

 Res := AR_NIL;
 While Res=AR_NIL Do
  If GetKey(k,f) Then
   Begin
    If Not(f) Then
     Begin
      Case UpCase(k) Of
       'A',#27 : Res := AR_Abandon;
       'R' : Res := AR_Reprise;
       'C' : If EtContinuer Then Res := AR_Continuer;
      End;
     End;
   End;

 PopZn;

 AbandonOuReprise := Res;
End;


Function InitMinitel : Boolean;
Const X = 12; Y = 10; Lg=56; Ht=3;
Var Res : ARResult;
    NbR : Word;
Begin
 If ComSilence Then InitMinitel := TRUE
 Else
  Begin
   PushZc(X,Y,Lg,Ht);

   ClrZc(X,Y,Lg,Ht,CRien);
   CdrZc(X,Y,Lg,Ht, CdrTab[2], CRien );
   WrtScr(CentreString('Un instant ...',Lg-2,32),X+1,Y+1,CTout);

   NbR := 0;
   Repeat
    Inc(NbR);
    If MinDetect(Speed1200,ComSlow Or (NbR>2),FALSE) Then Res := AR_NIL
    Else Res := AbandonOuReprise('','Minitel local non prt','',FALSE);
   Until Res<>AR_Reprise;

   PopZn;

   InitMinitel := Res=AR_NIL;
  End;
End;


Function GoodParam : Boolean;
Begin
 GoodParam := FALSE;
 If ComUART=0 Then Writeln('PORT DE COMMUNICATION ABSENT')
 Else
  If ComIRQ>15 Then Writeln('NUMERO D''IRQ INCORRECT')
  Else GoodParam := TRUE;
End;


Procedure MyExit; Far;
Begin
 ExitProc := SaveExit;
 SetIntVec($1C,ExInt1C);
 SetIntVec($1B,ExInt1B);
End;


Function FoncTas( lg : Word ) : Word; Far;
Begin
 If lg>0 Then FoncTas := 0;
End;


Procedure InitSoft;
Begin
 C18 := 0;

 GetIntVec($1C,ExInt1C);
 SetIntVec($1C,@NewInt1C);

 BreakDetect := FALSE;

 GetIntVec($1B,ExInt1B);
 SetIntVec($1B,@NewInt1B);


 SaveExit := ExitProc;
 ExitProc := @MyExit;

 CheckBreak := FALSE;  (* desactive CTRL BREAK *)

 New(Em.Ram);
 ClearRam(Em.Ram);

 If EmulDRCS Then
  Begin
   New(Em.DRCS);
   ClearRamDRCS(Em.DRCS);
  End
 Else Em.DRCS := NIL;

 HeapError := @FoncTas;
End;


Procedure CreatMainMenu;
Begin
 WrtScr('C A P T E L',1,0,CRien);
 CdrZc(0,1,40,24, CdrTab[2], CRien );
 WrtScr('Suivi des oprations:',1,2,CRien);
 FillZc(1,3,38,1,Byte(''),CRien);
 WrtDt(Byte(''),0,13,CRien);
 FillZc(1,13,38,1,Byte(''),CRien);
 WrtDt(Byte(''),39,13,CRien);
 WrtScr('Automate: (L.----)Emulation:         ',1,14,CRien);
 WrtScr('ĳ',1,15,CRien);
 WrtScr('F1 Executer       F5 Imprimer        ',1,16,CRien);
 WrtScr('F2 Arrter/QuitterF6 Sauver          ',1,17,CRien);
 WrtScr('F3 Informations   F7 Ajouter         ',1,18,CRien);
 WrtScr('                                     ',1,19,CRien);
 WrtScr('                                     ',1,20,CRien);
 WrtScr('                  F0 Pause/Reprise   ',1,21,CRien);
 WrtScr('F1',1,16,CRvs);
 WrtScr('F2',1,17,CRvs);
 WrtScr('F3',1,18,CRvs);
 WrtScr('F5',20,16,CRvs);
 WrtScr('F6',20,17,CRvs);
 WrtScr('F7',20,18,CRvs);
 WrtScr('F0',20,21,CRvs);

 FillZc(1,22,38,1,Byte(''),CRien);
End;


Procedure MyWriteln( Texte : String ); Far;
Const BX = 1;
      BY = 4;
      Lg = 38;
      Ht = 9;

      X : Byte = 0;
      Y : Byte = 0;
Var i : Byte;
Begin
 For i := 1 To Length(Texte) Do
  Begin
   WrtDt(Byte(Texte[i]),BX+X,BY+Y,CTout);
   Inc(X);
   If X>=Lg Then
    Begin
     X := 0;
     Inc(Y);
     If Y>=Ht Then
      Begin
       Y := Ht-1;
       ZcUp(BX,BY,Lg,Ht,1,CTout);
      End;
    End;
  End;
 { Return }
 X := 0;
 Inc(Y);
 If Y>=Ht Then
  Begin
   Y := Ht-1;
   ZcUp(BX,BY,Lg,Ht,1,CTout);
  End;
End;


Procedure EmulStr( Texte : String );
Var i : Byte;
Begin
 For i := 1 To Length(Texte) Do Emul(Em,Texte[i]);
End;


Procedure AffRollOff;
Begin
 WrtScr('( page  )',30,0,CRien);
 AffMdPage := TRUE;
End;


Procedure AffRollOn;
Begin
 WrtScr('(rouleau)',30,0,CRien);
 AffMdPage := FALSE;
End;


Procedure AffEmulModePage;
Begin
 If Em.Stat.MdPage<>AffMdPage Then
  If Em.Stat.MdPage Then AffRollOff Else AffRollOn;
End;


Function  ReceiveAndEmul : Char;
Var c : Char;
    r : Word;
Begin
 If Com.ReceiveChar(c) Then
  Begin
   r := Emul(Em,c);

   If EmulAuto And (r=EMOP_CHGSTATUSFONC) Then Com.Write(#$1B#$39#$72);

   AffEmulModePage;

   ReceiveAndEmul := c;
  End
 Else ReceiveAndEmul := #0;
End;


Const AttExclude = AttBitUnused;

Procedure ExcludeLine( y : Byte );
Var x : Byte;
Begin
 If y<ScreenHigh Then
  Begin
   For x := 0 To ScreenLong-1 Do
    With Em.Ram^[y,x] Do Att := Att Or AttExclude;
  End;
End;


Procedure ExcludeAll;
Var y : Byte;
Begin
 For y := 0 To ScreenHigh-1 Do ExcludeLine(y);
End;


{ Tous les car "parasite sont traduit en espace" ou en code "visible" }
Function GetStrFromRam( x, y, lg : Byte; Ex : Boolean ) : String;
Var s : String;
    g : PVDispRamEl;
    c : Char;
Begin
 If (x>=ScreenLong) Or (y>=ScreenHigh) Then GetStrFromRam := ''
 Else
  Begin
   If x+lg>ScreenLong Then lg := ScreenLong-x;
   s[0] := #0;
   While lg>0 Do
    Begin
     g := @Em.Ram^[y,x];
     If g^.Car=#0 Then c := ' '
     Else
      If (g^.Att And Graphik<>0) Or
         (Ex And (g^.Att And AttExclude<>0)) Then c := ' '
      Else
       Begin
        If g^.Car<#32 Then
         Begin
          Case g^.Car Of
            #21 : c := '';
            #24 : c := '';
            #25 : c := '';
            #26 : c := '';
            #27 : c := '';
          Else c := ' ';
          End;
         End
        Else
         Case g^.Car Of
          Char(Complement) : c := ' ';
          #127 : c := '';
         Else c := g^.Car;
         End;
       End;

     Inc(s[0]);
     s[Length(s)] := c;
     Inc(x);
     Dec(lg);
    End;
   GetStrFromRam := s;
  End;
End;



{$I CAPTLX.PAS }

Procedure AffPauseOff;
Begin
 AspZc(23,21,16,1,CRien);
 GenPause := FALSE;
End;


Procedure AffPauseOn;
Begin
 AspZc(23,21,16,1,CRvs);
 GenPause := TRUE;
End;


Procedure PauseOnOff;
Begin
 If GenPause Then AffPauseOff Else AffPauseOn;
End;


{ Active la pause, mais renvoi l'etat courant ( sauver) }

Function  ForcePauseOn : Boolean;
Begin
 ForcePauseOn := GenPause;
 If Not(GenPause) Then AffPauseOn;
End;


Procedure RestorePause( Pause : Boolean );
Begin
 GenPause := Pause;
 If Pause Then AffPauseOn Else AffPauseOff;
End;


Procedure AffEntree( x , y : Byte );
Begin
 WrtScr('Entre'#17'',x,y,CRvs);
End;


function InputString(var texte : string; var c_pos : word; max,lg_chp,col,ligne : byte) : boolean;
{ pos_central=position caractre ou positionner le curseur ... }
var tempo,OfsX : integer;
    EndBoucle : boolean;
    index : byte;
    pos : integer;
    r   : word;
type Car_Rec = record
         car : byte;
         att : byte;
       end;
var CarLeft,
    CarRight,
    FleLeft,
    FleRight : Car_Rec;
  procedure InChamp;
  var buf   : string;
  begin
    FillChar(buf[1],lg_chp,32);
    buf[0] := char(lg_chp);
    move(texte[r+1],buf[1],length(texte)-r);
    WrtScr(buf,col,ligne,CRvs);

    if r>0 then ToScr(@FleLeft,col-1,ligne,1)
    else toScr(@CarLeft,col-1,ligne,1);
    if length(texte)>(r+lg_chp) then ToScr(@FleRight,col+lg_chp,ligne,1)
    else toScr(@CarRight,col+lg_chp,ligne,1);
  end;

Var Key   : Char;
    Funct : Boolean;
begin

  FromScr(@CarLeft,col-1,ligne,1);
  FromScr(@CarRight,col+lg_chp,ligne,1);
  FleLeft.car := 17;
  FleLeft.att := CRien;
  FleRight.car := 16;
  FleRight.att := CRien;

  EndBoucle := false;
  if c_pos=0 then pos := 0
  else pos := c_pos-1;
  if pos>length(texte) then pos := length(texte);

  if pos<(lg_chp div 2) then r := 0
  else
    if pos+(lg_chp div 2)<length(texte) then r := pos-(lg_chp div 2)
    else
      if length(texte)<lg_chp then r := 0
      else
        begin
          r := (length(texte)-lg_chp); { (pos-lg_chp+1); }
          if pos=length(texte) then inc(r);
        end;

  CurOn;
  CurBig;

  repeat
{    WrtScr('"'+texte+'"',0,0,TNet);
    GotoXY(1,10);
    write('length(texte)=',length(texte),' pos=',pos,' r=',r,' max=',max);
    }
    InChamp;
    OfsX := (pos-r)+1;
    GotoXY(col+OfsX,ligne+1);
    If GetKey(Key,Funct) Then
      if Not(FUNCT) then
        case key of
          #9 : begin { tab }
                 if pos mod 8=0 then inc(pos,8)
                 else pos := (pos div 8)*8+8;
                 if pos>length(texte) then pos := length(texte);
                 if (pos-r+1)>lg_chp then r := (pos-lg_chp+1);
               end;
          #8 : begin {  del  }
                 if pos>0 then
                   begin
                     if pos<length(texte) then
                       move(texte[pos+1],texte[pos],length(texte)-pos);
                     dec(texte[0]);
                     dec(pos);
                     if (r>0) and (r>=pos) then dec(r);
                   end;
               end;
          #13 : begin {  return  }
                  EndBoucle := true;
                end;
          #25 : begin {  CTRL+Y  }
                  pos := 0;
                  r := 0;
                  texte := '';
                end;
          #27 : begin {  ESC  }
                  EndBoucle := true;
                end;
          #32..#255 : begin
                        if pos<max then
                          begin
                            inc(pos);
                            texte[pos] := key;
                            if length(texte)<pos then texte[0] := char(pos);
                            if (pos-r+1)>lg_chp then inc(r);
                          end;
                      end;
        end {  case of  }
      else { funct }
        case key of
          #15: begin { shift tab }
                 if pos mod 8=0 then dec(pos,8)
                 else dec(pos,pos mod 8);
                 if pos<0 then pos := 0;
                 if r>pos then r := pos;
               end;
          #71: begin { Home }
                 pos := 0;
                 r   := 0;
               end;
          #75: begin { <- }
                 if pos>0 then
                   begin
                     dec(pos);
                     if (r>0) and (r>pos) then dec(r);
                   end;
               end;
          #77: begin { -> }
                 if pos<length(texte) then
                   begin
                     inc(pos);
                     if (pos-r+1)>lg_chp then inc(r);
                   end;
               end;
          #79: begin { End }
                 pos := length(texte);
                 if pos>=lg_chp then r := (pos-lg_chp+1) else r := 0;
               end;
          #82: begin { Ins }
                 if length(texte)<max then
                   begin
                     move(texte[pos+1],texte[pos+2],length(texte)-(pos));
                     texte[pos+1] := '';
                     inc(texte[0]);
                   end;
               end;
          #83: begin { del }
                 if pos<length(texte) then
                   begin
                     if pos+1<length(texte) then
                       move(texte[pos+2],texte[pos+1],length(texte)-(pos+1));
                     dec(texte[0]);
                   end;
               end;
        end;
  until EndBoucle;
  { suppression des vides }
  r := 1;
  while r<=length(texte) do
    begin
      if (texte[r]='') then
        begin
          move(texte[r+1],texte[r],length(texte)-r);
          dec(texte[0]);
        end
      else inc(r);
    end;
  c_pos := pos+1;
  InputString := key=#13;

  ToScr(@CarLeft,col-1,ligne,1);
  ToScr(@CarRight,col+lg_chp,ligne,1);

  CurOff;
end;


Procedure AffEchap( x, y, lg : Byte );
Const z = 'Echap pour abandonner';
Var p : Byte;
Begin
 p := CentralPos(Length(z),lg);

 WrtScr(z,x+p,y,CRien);
 AspZc(x+p,y,5,1,CRvs);
End;


Procedure AffWinWait( Texte1, Texte2 : String );
Const X = 18; Y = 9; Lg=44; Ht=6;
Begin
 PushZc(X,Y,Lg,Ht);
 ClrZc(X,Y,Lg,Ht,CRien);
 CdrZc(X,Y,Lg,Ht,CdrTab[2],CRien);
 WrtScr(CentreString(Texte1,Lg-2,32),X+1,Y+1,CTout);
 WrtScr(CentreString(Texte2,Lg-2,32),X+1,Y+2,CTout);
 WrtScr('Abandon',X+3,Y+Ht-2,CRien);
 WrtDt(Byte('A'),X+3,Y+Ht-2,CRvs);
End;

Function PrinterReady( nLpt : Word ) : Boolean;
Var Reg : Registers;
Begin
 Reg.AH := $02;
 Reg.DX := nLpt-1;
 Intr($17,reg);
 PrinterReady := ((Reg.AH And ($21+144))=144);
End;

Function PrintChar( nLpt : Word; c : Char ) : Boolean;
Var Reg   : Registers;
Begin
 Reg.DX := nLpt-1;
 Reg.AH := 0;
 Reg.AL := Byte(c);
 Intr($17,Reg);
 PrintChar := ((Reg.AH And ($21+16))=16);
End;


Function  ImprimerVers( nLpt : Word ) : Boolean;
Var x, y : Byte;
    Res  : ARResult;
    s    : String;
Begin
 AffWinWait('Impression en cours ...','');

 Repeat
  If PrinterReady(nLpt) Then Res := AR_NIL
  Else Res := AbandonOuReprise('','Imprimante incontrlable','',FALSE);
 Until Res<>AR_Reprise;

 If Res=AR_NIL Then
  Begin
   y := 1;
   While (Res=AR_NIL) And (y<ScreenHigh) Do
    Begin
     s := GetStrFromRam(0,y,ScreenLong,FALSE);
     StrPlaneRight(s);
     s := s+#13#10;
     x := 0;
     While (Res=AR_NIL) And (x<length(s)) Do
      If KeyAbort Then Res := AR_Abandon
      Else
       If PrintChar(nLpt,s[x+1]) Then
        Begin
         Res := AR_NIL;
         Inc(x);
        End
       Else
        Begin
         Res := AbandonOuReprise('','Imprimante incontrlable','',FALSE);
         If Res=AR_Reprise Then Res := AR_NIL;
        End;
     Inc(y);
    End;
  End;

 ImprimerVers := Res=AR_NIL;

 PopZn;
End;


Procedure Imprimer;
Const X = 20; Y = 8; Lg=40; Ht=7;
Var ExPause : Boolean;
    cpos    : Word;
    Res     : ARResult;
    nLpt    : Word;
    Err     : Word;
Begin
 ExPause := ForcePauseOn;

 PushZc(X,Y,Lg,Ht);

 ClrZc(X,Y,Lg,Ht,CRien);
 CdrZc(X,Y,Lg,Ht, CdrTab[2], CRien );
 WrtScr(CentreString('Numro d''imprimante ?',Lg-2,32),X+1,Y+1,CTout);
 WrtScr('LPT',X+5+6,Y+3,CTout);
 AffEntree(X+12+6,Y+3);
 AffEchap(X+1,Y+5,Lg-2);


 cpos := Length(LPTStr)+1;

 Repeat
  If Not(InputString(LPTStr,cpos,SizeOf(LPTStr)-1,2,X+9+6,Y+3)) Then Res := AR_Abandon
  Else
   Begin
    Val(LPTStr,nLpt,Err);
    If Err<>0 Then Res := AbandonOuReprise('','Numro d''imprimante incorrect','',FALSE)
    Else
     Begin
      If ImprimerVers(nLpt) Then Res := AR_NIL
      Else Res := AR_Reprise;
     End;
   End;
 Until Res<>AR_Reprise;

 PopZn;


 RestorePause(ExPause);
End;



Function  SauverVers( Var f : Text ) : Boolean;
Var y    : Byte;
    Res  : ARResult;
    s    : String;
    io   : Word;
Begin
 AffWinWait('Sauvegarde en cours ...','');

 Res := AR_NIL;

 y := 1;
 While (Res=AR_NIL) And (y<ScreenHigh) Do
  Begin
   s := GetStrFromRam(0,y,ScreenLong,FALSE);
   StrPlaneRight(s);
   If KeyAbort Then Res := AR_Abandon
   Else
    Begin
     Writeln(f,s);
     io := IoResult;
     If io=0 Then Inc(y)
     Else
      Begin
       Res := AbandonOuReprise('','Dfauts d''accs disque','',FALSE);
       If Res=AR_Reprise Then Res := AR_NIL;
      End;
    End;
  End;

 SauverVers := Res=AR_NIL;

 PopZn;
End;


Procedure Sauver;
Const X = 10; Y = 8; Lg=60; Ht=7;
Var ExPause : Boolean;
    cpos    : Word;
    Res     : ARResult;
    f       : Text;
    io      : Word;
Begin
 ExPause := ForcePauseOn;

 PushZc(X,Y,Lg,Ht);

 ClrZc(X,Y,Lg,Ht,CRien);
 CdrZc(X,Y,Lg,Ht, CdrTab[2], CRien );
 WrtScr(CentreString('Sauver en ASCII',Lg-2,32),X+1,Y+1,CTout);
 WrtScr('Nom du fichier:',X+1,Y+3,CTout);
 AffEntree(X+1+24+26,Y+3);
 AffEchap(X+1,Y+5,Lg-2);


 cpos := Length(SaveStr)+1;

 Repeat
  If Not(InputString(SaveStr,cpos,SizeOf(SaveStr)-1,26+8,X+24-8,Y+3)) Then Res := AR_Abandon
  Else
   If SaveStr='' Then Res := AR_Reprise
   Else
    Begin
     Assign(f,SaveStr);
     Reset(f);
     io := IOResult;
     If (io=2) Or (io=0) Then
      Begin
       Res := AR_Continuer;
       If (io=0) Then
        Begin
         Res := AbandonOuReprise('','Fichier Existant dj !','',TRUE);
         Close(f);
        End;
       If Res=AR_Continuer Then
        Begin
         Rewrite(f);
         io := IOResult;
         If io<>0 Then Res := AbandonOuReprise('','Erreur d''accs disque','',FALSE)
         Else
          Begin

           SauverVers(f);

           Close(f);
          End;
        End;
      End
     Else Res := AbandonOuReprise('','Erreur d''accs disque','',FALSE);
    End;
 Until Res<>AR_Reprise;

 PopZn;


 RestorePause(ExPause);
End;


Procedure Ajouter;
Const X = 10; Y = 8; Lg=60; Ht=7;
Var ExPause : Boolean;
    cpos    : Word;
    Res     : ARResult;
    f       : Text;
    io      : Word;
Begin
 ExPause := ForcePauseOn;

 PushZc(X,Y,Lg,Ht);

 ClrZc(X,Y,Lg,Ht,CRien);
 CdrZc(X,Y,Lg,Ht, CdrTab[2], CRien );
 WrtScr(CentreString('Ajouter (et Sauver) en ASCII',Lg-2,32),X+1,Y+1,CTout);
 WrtScr('Nom du fichier:',X+1,Y+3,CTout);
 AffEntree(X+1+24+26,Y+3);
 AffEchap(X+1,Y+5,Lg-2);


 cpos := Length(SaveStr)+1;

 Repeat
  If Not(InputString(SaveStr,cpos,SizeOf(SaveStr)-1,26+8,X+24-8,Y+3)) Then Res := AR_Abandon
  Else
   If SaveStr='' Then Res := AR_Reprise
   Else
    Begin
     Assign(f,SaveStr);
     Append(f);
     io := IOResult;
     If (io=2) Or (io=0) Then
      Begin
       Res := AR_Continuer;
       If (io=2) Then
        Begin
         Res := AbandonOuReprise('','Ce fichier n''existe pas !','',TRUE);
         If Res=AR_Continuer Then
          Begin
           Rewrite(f);
           io := IOResult;
           If io<>0 Then Res := AbandonOuReprise('','Erreur d''accs disque','',FALSE);
          End;
        End;
       If Res=AR_Continuer Then
        Begin
         SauverVers(f);

         Close(f);
        End;
      End
     Else Res := AbandonOuReprise('','Erreur d''accs disque','',FALSE);
    End;
 Until Res<>AR_Reprise;

 PopZn;


 RestorePause(ExPause);
End;


Procedure ForceTelixOn;
Begin
 TelixRun := TRUE;
 AspZc(4,16,15,1,CRvs);
End;

Procedure ForceTelixOff;
Begin
 TelixRun := FALSE;
 AspZc(4,16,15,1,CRien);
 WrtScr('----',14,14,CRien);
End;

Procedure UpDateLineNumber;
Var s : String[10];
Begin
 s := '';
 Str0Int(s,TelixGetnLine,4);
 WrtScr(s,14,14,CTout);
End;


Procedure Executer;
Const X = 10; Y = 8; Lg=60; Ht=7;
Var ExPause : Boolean;
    cpos    : Word;
    Res     : ARResult;
Begin
 ExPause := ForcePauseOn;

 If TelixRun Then Beep  { dj en cours !!! }
 Else
  Begin  { lancer... }
   PushZc(X,Y,Lg,Ht);

   ClrZc(X,Y,Lg,Ht,CRien);
   CdrZc(X,Y,Lg,Ht,CdrTab[2],CRien);

   WrtScr(CentreString('Executer les instructions "TELIX"',Lg-2,32),X+1,Y+1,CTout);
   WrtScr('Nom du fichier:',X+1,Y+3,CTout);
   AffEntree(X+1+24+26,Y+3);
   AffEchap(X+1,Y+5,Lg-2);


   cpos := Length(TelixStr)+1;

   Repeat
    If Not(InputString(TelixStr,cpos,SizeOf(TelixStr)-1,26+8,X+24-8,Y+3)) Then Res := AR_Abandon
    Else
     Begin
      If TelixInit(TelixStr) Then
       Begin
        CapTlxInit;
        Res := AR_NIL;
       End
      Else
       Begin
        Res := AbandonOuReprise('','Fichier introuvable','',FALSE);
       End;
     End;
   Until Res<>AR_Reprise;

   PopZn;

   If Res=AR_NIL Then
    Begin
     ForceTelixOn;
    End;
  End;

 RestorePause(ExPause);
End;


Procedure Arreter;
Const X = 10; Y = 8; Lg=60; Ht=7;
Var ExPause : Boolean;
    Res     : ARResult;
Begin
 ExPause := ForcePauseOn;

 If Not(TelixRun) Then Beep
 Else
  Begin
   Res := AbandonOuReprise('','Arrter l''xecution ...','Vous tes sr ?',TRUE);
   If Res=AR_Continuer Then
    Begin
     TelixDone;
     ForceTelixOff;
    End;
  End;

 RestorePause(ExPause);
End;


Function  Quitter : Boolean;
Var ExPause : Boolean;
    Res     : ARResult;
Begin
 ExPause := ForcePauseOn;
 Quitter := AR_Continuer=AbandonOuReprise('','Quitter CAPTEL ...','Vous tes sr ?',TRUE);
 RestorePause(ExPause);
End;



Function PresenteSoft( Echap : Boolean ) : Boolean;
Const X = 18; Y = 6; Lg=44; Ht=11;
Var k : Char;
    f : Boolean;
Begin
 PushZc(X,Y,Lg,Ht);

 ClrZc(X,Y,Lg,Ht, CRien);
 CdrZc(X,Y,Lg,Ht, CdrTab[2], CRien );

 WrtScr('CAPTEL',X+20,Y+1,CTout);
 WrtScr('',X+20,Y+2,CRien);
 WrtScr('Version 1.1',X+18,Y+3,CRien);
 WrtScr('Copyright (c) 1991,92 W.M.Edition',X+6,Y+5,CTout);
 WrtScr('Tapez une touche pour continuer',X+7,Y+Ht-4,CRvs);
 If Echap Then
  Begin
   WrtScr('Echap pour quitter',X+14,Y+Ht-2,CRien);
   WrtScr('Echap',X+14,Y+Ht-2,CRvs);
  End;

 While Not(GetKey(k,f)) Do;

 PopZn;

 PresenteSoft := f Or (k<>#27);
End;


Procedure Information;
Var ExPause : Boolean;
Begin
 ExPause := ForcePauseOn;
 PresenteSoft(FALSE);
 RestorePause(ExPause);
End;


Procedure MainLoop;
Var Key   : Char;
    Funct : Boolean;
Begin
 While TRUE Do
  Begin
   If Not(GenPause) And Not(TelixRun) Then ReceiveAndEmul;
   If GetKey(Key,Funct) Then
    Begin
     If Funct Then
      Begin
       Case Key Of
        #59 : Executer; { F1 }
        #60 : If TelixRun Then Arreter  { F2 }
              Else If Quitter Then Exit;
        #61 : Information;   { F3 }
        #62 : ;
        #63 : Imprimer; { F5 : Imprimer }
        #64 : Sauver; { F6 : Sauver }
        #65 : Ajouter; { F7 : Ajouter }
        #66 : ; { F8 }
        #67 : ; { F9 }
        #68 : PauseOnOff; { F10 }
        #45,#16 : If Quitter Then Exit;  { Alt+X ou Alt+Q }
        #$FF,#3 : If TelixRun Then Arreter  { Ctrl+Break }
                  Else If Quitter Then Exit;
       Else Beep;
       End;
      End
     Else
      Begin
       If Key=#27 Then
        Begin
         If Quitter Then Exit;
        End
       Else Beep;
      End;
    End;
   If TelixRun And Not(GenPause) Then
    If TelixExecute Then UpDateLineNumber
    Else
     Begin
      TelixDone;
      ForceTelixOff;
     End;
  End;
End;


Procedure Main;
Begin
 CurOff;
 FillZc(0,0,80,25,32,CRien);

 CreatMainMenu;

 InitEmul(Em,Em.Ram,Em.DRCS);

 Em.Cfg.VisuelConvert := TRUE;
 Em.Cfg.RTIC       := EmulRTIC;
 Em.Cfg.InsLowOnly := EmulInsLow;
 Em.Cfg.C15Clr     := EmulC15Clr;
 Em.Cfg.ToScreen   := TRUE;
 Em.Cfg.SX         := 40;
 Em.Cfg.SY         := 0;
 Em.Stat.MdIns     := FALSE;
 Em.Stat.MdPage    := TRUE;

 AffRollOff;
 EmulStr(#$1F'@A'#24#12);

 GenPause := FALSE;

 Str(LPTNum,LPTStr);
 SaveStr := '';

 ForceTelixOff;

 ExternalFindFunct := FindFunct;
 ExternalExecFunct := ExecFunct;
 ExternalWriteln := MyWriteln;

 MainLoop;
End;


Procedure DoThatForHelp;
Begin
 Writeln('Tapez  CAPTEL /?  afin d''obtenir une aide rapide');
End;


Begin
 TelixStr := 'CAPTEL.TLX';

 If Not(ChargeParam) Then DoThatForHelp
 Else
  If NeedHelp Then
   Begin
    Writeln('CAPTEL  v1.1, Copyright (c) 1991,92 W.M.Edition');
    Writeln;
    Writeln(' /MDA   video hercule, mono...        | /CGA   video couleurs: ega, vga...');
    Writeln(' /COMx  1, 2, 3 ou 4 (standard DOS)   | /COM=  ...{uart},{irq}');
    Writeln(' /BUF=  ...{entres},{sorties}        | /SLOW initialisation lente');
    Writeln(' /SIL  ignore minitel local          | /ED   mule D.R.C.S. (M2+)');
    Writeln(' /ER   mule minitel RTIC (M1B)      | /EI   mule bogue insertion (M2+)');
    Writeln(' /EC   mule bogue soulignement (M2+)| /EA   passage rouleau/page automatique');
    Writeln(' /LPT=  ...{numro d''imprimante}      | /TLX=  ...{fichier "telix"}');
    Writeln;
    Writeln('Fichier de configuration: CAPTEL.CFG');
    Writeln;
   End
  Else
   If Not(GoodParam) Then DoThatForHelp
   Else
    Begin
     InitSoft;

     VideoInit;

     CurOff;
     FillZc(0,0,80,25,32,CRien);


     If PresenteSoft(TRUE) Then
      Begin
       If Com.Init(ComUART,ComIRQ,BAUD1200,EVENPARITY+DATA7BITS+STOP1BIT,ComIn,ComOut) Then
        Begin

         If InitMinitel Then Main;

         MinRestoreSpeed;

         Com.Done;
        End;
      End;

     VideoDone;
    End;
End.
