{*************************************
 *                                   *
 *          C A P - T e L i X        *
 *                                   *
 *************************************}

Var TimeOut     : Word;
    ExcludeMode : Boolean;
    FastSend    : Boolean;

Type FunctStr = String[16];

     FunctRef = (FR_NIL,
                 FR_SEND,
                 FR_WAITOUTEMPTY,
                 FR_SETTIMEOUT,
                 FR_WAITFLOW,
                 FR_WAITFLOWSTR,
                 FR_ONLINE,
                 FR_WAITSILENCE,
                 FR_WAITXDATAS,
                 FR_RECEIVESTR,
                 FR_GETSTRXY,
                 FR_GETC18,
                 FR_COMCLEAR,
                 FR_CHECKSTRXY,
                 FR_CHECKXY,
                 FR_WAITXY,
                 FR_ENVOI,
                 FR_RETOUR,
                 FR_REPETITION,
                 FR_GUIDE,
                 FR_ANNULATION,
                 FR_SOMMAIRE,
                 FR_CORRECTION,
                 FR_SUITE,
                 FR_CNXFIN,
                 FR_EXCLUDEMODE,
                 FR_EXCLUDELINE,
                 FR_EXCLUDEALL,
                 FR_DERNIERE);

Const TabFunct : Array[Succ(FR_NIL)..Pred(FR_DERNIERE)] Of FunctStr = (
       'SEND',
       'WAITOUTEMPTY',
       'SETTIMEOUT',
       'WAITFLOW',
       'WAITFLOWSTR',
       'ONLINE',
       'WAITSILENCE',
       'WAITXDATAS',
       'RECEIVESTR',
       'GETSTRXY',
       'GETC18',
       'COMCLEAR',
       'CHECKSTRXY',
       'CHECKXY',
       'WAITXY',
       'ENVOI',
       'RETOUR',
       'REPETITION',
       'GUIDE',
       'ANNULATION',
       'SOMMAIRE',
       'CORRECTION',
       'SUITE',
       'CNXFIN',
       'EXCLUDEMODE',
       'EXCLUDELINE',
       'EXCLUDEALL'
       );

Function  FindFunct( Funct : String ) : Word; Far;
Var i : FunctRef;
Begin
 For i := Succ(FR_NIL) To Pred(FR_DERNIERE) Do
  If Funct=TabFunct[i] Then
   Begin
    FindFunct := Ord(i);
    Exit;
   End;
 FindFunct := 0;
End;



{ word = SEND( str [ , str ... ] ) }

Procedure Funct_SEND( Var Dest : VarRec );
Var s : String;
    d : String;
    how : Word;
    i : Byte;
    Ti : Longint;
Begin
 If CheckParOuv(GetInstr) Then
  Begin
   how := 0;

   Repeat
    s := GetInstr;
    If InstrToStr(s,s) Then
     Begin
      If s<>'' Then
       Begin
        d := '';
        IbmVdt(s,d);
        If FastSend Then Com.Write(d)
        Else
         Begin { envoi lent... }
          For i := 1 To length(d) Do
           Begin
            Com.Write(d[i]);
            Ti := GetC18;
            While (GetC18-Ti<2) Do If BreakDetect Then Exit;
           End;
         End;

        Inc(how,length(s));
       End;
      s := GetInstr;
     End
    Else Exit;

   Until Not(TestVirgule(s));

   If CheckParFer(s) Then
    Begin
     Dest.Tp := VR_WORD;
     Dest.Wr := how;
    End;
  End;
End;


{ bool = FastSend(bool) }

Procedure Funct_FASTSEND( Var Dest : VarRec );
Var b : Boolean;
Begin
 If CheckParOuv(GetInstr) And InstrToBool(GetInstr,b) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_BOOL;
   Dest.Bl := FastSend;
   FastSend := b;
  End;
End;


{ WaitOutEmpty }

Procedure Funct_WAITOUTEMPTY( Var Dest : VarRec );
Begin
 Com.WaitOutEmpty;
End;


{ word = SetTimeOut(word) }

Procedure Funct_SETTIMEOUT( Var Dest : VarRec );
Var n : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,n) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_WORD;
   Dest.Wr := TimeOut;   { renvoi l'ancien timeout }
   TimeOut := n;
  End;
End;


Function WaitFlowStr( Texte : String; TiMax : Word;
                      Var Res : String ) : Boolean;
Var iRead : Byte;
    TiDeb : Longint;
    c     : Char;
Begin
 iRead := 0;
 TiDeb := GetC18;
 TiMax := TiMax Div 55;

 While iRead<Length(Texte) Do
  Begin
   Repeat
    If ((GetC18-TiDeb)>=TiMax) Or BreakDetect Then
     Begin
      WaitFlowStr := FALSE;
      Exit;
     End;
    c := ReceiveAndEmul;
   Until (c<>#0);  { Ignore les 0 }

   Inc(iRead);
   If (Texte[iRead]=#0) Or (Texte[iRead]=#1) Or (Texte[iRead]=c) Then
    Begin
     Res[iRead] := c;
    End
   Else
    If (Texte[1]=#0) Or (Texte[1]=#1) Or (Texte[1]=c) Then iRead := 1 Else iRead := 0;
  End;

 Res[0] := Texte[0];
 WaitFlowStr := TRUE;
End;


{ bool = WaitFlow(str[,word]) }

Procedure Funct_WAITFLOW( Var Dest : VarRec );
Var s : String;
    t : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) Then
  Begin
   s := GetInstr;
   If TestVirgule(s) Then
    Begin
     If Not(InstrToWord(GetInstr,t)) Then Exit;
     s := GetInstr;
    End
   Else t := TimeOut;

   If CheckParFer(s) Then
    Begin
     Dest.Tp := VR_BOOL;

     If WaitFlowStr(Dest.Str^,t,Dest.Str^) Then
      Begin
       Dest.Bl := TRUE;
      End
     Else Dest.Bl := FALSE;
    End;
  End;
End;


{ str = WaitFlowStr(str[,word]) }

Procedure Funct_WAITFLOWSTR( Var Dest : VarRec );
Var s : String;
    t : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) Then
  Begin
   s := GetInstr;
   If TestVirgule(s) Then
    Begin
     If Not(InstrToWord(GetInstr,t)) Then Exit;
     s := GetInstr;
    End
   Else t := TimeOut;

   If CheckParFer(s) Then
    Begin
     Dest.Tp := VR_STR;

     If WaitFlowStr(Dest.Str^,t,Dest.Str^) Then
      Begin
      End
     Else
      Begin
       Dest.Str^ := '';
      End;
    End;
  End;
End;


{ bool = online }

Procedure Funct_ONLINE( Var Dest : VarRec );
Begin
 Com.Write(MPRO1+#$70);
 Com.WaitOutEmpty;

 Dest.Tp := VR_BOOL;
 If WaitFlowStr(MPRO2+#$71#$00,2000,Dest.Str^) Then
  Begin
   Dest.Bl := (Byte(Dest.Str^[4]) And 8<>0);
  End
 Else Dest.Bl := FALSE;
End;


Function WaitSilence( TiSil, TiMax : Word ) : Boolean;
Var TiDeb : Word;
    TiLoc : Word;
    Ti    : Word;
    c     : Char;
Begin
 TiSil := TiSil Div 55;
 TiMax := TiMax Div 55;
 TiDeb := GetC18;
 TiLoc := GetC18;

 Repeat
  Ti := GetC18;
  If (Ti-TiDeb>=TiMax) Or BreakDetect Then
   Begin
    WaitSilence := FALSE;
    Exit;
   End;
  c := ReceiveAndEmul;
  If c<>#0 Then TiLoc := Ti;
 Until Ti-TiLoc>=TiSil;

 WaitSilence := TRUE;
End;


{ bool = WaitSilence(word[,word]) }

Procedure Funct_WAITSILENCE( Var Dest : VarRec );
Var s : String;
    TiSil : Word;
    t : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,TiSil) Then
  Begin
   s := GetInstr;
   If TestVirgule(s) Then
    Begin
     If Not(InstrToWord(GetInstr,t)) Then Exit;
     s := GetInstr;
    End
   Else t := TimeOut;

   If CheckParFer(s) Then
    Begin
     Dest.Tp := VR_BOOL;
     Dest.Bl := WaitSilence(TiSil,t);
    End;
  End;
End;


Function WaitXDatas( How : Word; TiMax : Word ) : Boolean;
Var TiDeb : Longint;
    c     : Char;
Begin
 TiDeb := GetC18;
 TiMax := TiMax Div 55;

 While How>0 Do
  Begin
   Repeat
    If ((GetC18-TiDeb)>=TiMax) Or BreakDetect Then
     Begin
      WaitXDatas := FALSE;
      Exit;
     End;
    c := ReceiveAndEmul;
   Until (c<>#0);  { Ignore les 0 }

   Dec(How);
  End;

 WaitXDatas := TRUE;
End;


{ bool = WaitXDatas(word[,word]) }

Procedure Funct_WAITXDATAS( Var Dest : VarRec );
Var s : String;
    How : Word;
    t : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToWord(GetInstr,How) Then
  Begin
   s := GetInstr;
   If TestVirgule(s) Then
    Begin
     If Not(InstrToWord(GetInstr,t)) Then Exit;
     s := GetInstr;
    End
   Else t := TimeOut;

   If CheckParFer(s) Then
    Begin
     Dest.Tp := VR_BOOL;
     Dest.Bl := WaitXDatas(How,t);
    End;
  End;
End;


Function ReceiveStr( Var Dest : String; Max : Word; TiMax : Word ) : Boolean;
Var TiDeb : Longint;
    c     : Char;
    iRead : Byte;
Begin
 TiDeb := GetC18;
 TiMax := TiMax Div 55;

 iRead := 0;
 While Max>0 Do
  Begin
   Repeat
    If ((GetC18-TiDeb)>=TiMax) Or BreakDetect Then
     Begin
      ReceiveStr := FALSE;
      Exit;
     End;
    c := ReceiveAndEmul;
   Until (c<>#0);  { Ignore les 0 }

   Dec(Max);
   Inc(iRead);
   Dest[iRead] := c;
  End;

 Dest[0] := Char(iRead);
 ReceiveStr := TRUE;
End;


{ str = ReceiveStr(word[,word]) }

Procedure Funct_RECEIVESTR( Var Dest : VarRec );
Var s : String;
    max : Byte;
    t : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToByte(GetInstr,max) Then
  Begin
   s := GetInstr;
   If TestVirgule(s) Then
    Begin
     If Not(InstrToWord(GetInstr,t)) Then Exit;
     s := GetInstr;
    End
   Else t := TimeOut;

   If CheckParFer(s) Then
    Begin
     Dest.Tp := VR_STR;
     If Not(ReceiveStr(Dest.Str^,max,t)) Then Dest.Str^ := '';
    End;
  End;
End;


{ str = GetStrXY(byte,byte,byte) }

Procedure Funct_GETSTRXY( Var Dest : VarRec );
Var x, y, lg : Byte;
Begin
 If CheckParOuv(GetInstr) And InstrToByte(GetInstr,x) And
    CheckVirgule(GetInstr) And InstrToByte(GetInstr,y) And
    CheckVirgule(GetInstr) And InstrToByte(GetInstr,lg) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp   := VR_STR;
   Dest.Str^ := GetStrFromRam(x,y,lg,ExcludeMode);
  End;
End;


Procedure Funct_GETC18( Var Dest : VarRec );
Begin
 Dest.Tp := VR_LONG;
 Dest.Lg := GetC18;
End;


Procedure Funct_COMCLEAR( Var Dest : VarRec );
Begin
 Com.Clear;
End;


{ str = CheckStrXY(str,x,y) }

Procedure Funct_CHECKSTRXY( Var Dest : VarRec );
Var s : String;
    x, y : Byte;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,s) And
    CheckVirgule(GetInstr) And InstrToByte(GetInstr,x) And
    CheckVirgule(GetInstr) And InstrToByte(GetInstr,y) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_STR;

   Dest.Str^ := GetStrFromRam(x,y,Length(s),ExcludeMode);
   If StrComp(s,Dest.Str^,TRUE)<>0 Then Dest.Str^ := ''; { renvoi RIEN }
  End;
End;


{ bool = CheckXY(str,x,y) }

Procedure Funct_CHECKXY( Var Dest : VarRec );
Var s : String;
    x, y : Byte;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,s) And
    CheckVirgule(GetInstr) And InstrToByte(GetInstr,x) And
    CheckVirgule(GetInstr) And InstrToByte(GetInstr,y) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_BOOL;

   Dest.Str^ := GetStrFromRam(x,y,Length(s),ExcludeMode);
   Dest.Bl := StrComp(s,Dest.Str^,TRUE)=0;
  End;
End;



Function WaitStrXY( Ref : String; x, y : Byte; TiMax : Word; Var Res : String ) : Boolean;
Var TiDeb : Longint;
    c     : Char;
    iRead : Byte;
    s     : String;
Begin
 TiDeb := GetC18;
 TiMax := TiMax Div 55;

 c := #1;   { afin de forcer un 1er test de ram au debut }

 While ((GetC18-TiDeb)<TiMax) And Not(BreakDetect) Do
  Begin
   If c<>#0 Then
    Begin
     s := GetStrFromRam(x,y,length(Ref),ExcludeMode);
     If StrComp(Ref,s,TRUE)=0 Then
      Begin
       Res := s;
       WaitStrXY := TRUE;
       Exit;
      End;
    End;
   c := ReceiveAndEmul;
  End;

 WaitStrXY := FALSE;
End;

(*
{ str = WaitStrXY(str,x,y[,word]) }

Procedure Funct_WAITSTRXY( Var Dest : VarRec );
Var s : String;
    x, y : Byte;
    t : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckVirgule(GetInstr) And InstrToByte(GetInstr,x) And
    CheckVirgule(GetInstr) And InstrToByte(GetInstr,y) Then
  Begin
   s := GetInstr;
   If TestVirgule(s) Then
    Begin
     If Not(InstrToWord(GetInstr,t)) Then Exit;
     s := GetInstr;
    End
   Else t := TimeOut;

   If CheckParFer(s) Then
    Begin
     Dest.Tp := VR_STR;
     If Not(WaitStrXY(Dest.Str^,x,y,t,Dest.Str^)) Then Dest.Str^ := '';
    End;
  End;
End;
*)


{ bool = WaitXY(str,x,y[,word]) }

Procedure Funct_WAITXY( Var Dest : VarRec );
Var s : String;
    x, y : Byte;
    t : Word;
Begin
 If CheckParOuv(GetInstr) And InstrToStr(GetInstr,Dest.Str^) And
    CheckVirgule(GetInstr) And InstrToByte(GetInstr,x) And
    CheckVirgule(GetInstr) And InstrToByte(GetInstr,y) Then
  Begin
   s := GetInstr;
   If TestVirgule(s) Then
    Begin
     If Not(InstrToWord(GetInstr,t)) Then Exit;
     s := GetInstr;
    End
   Else t := TimeOut;

   If CheckParFer(s) Then
    Begin
     Dest.Tp := VR_BOOL;
     Dest.Bl := WaitStrXY(Dest.Str^,x,y,t,Dest.Str^);
    End;
  End;
End;


{ bool = ExcludeMode(bool) }

Procedure Funct_EXCLUDEMODE( Var Dest : VarRec );
Var b : Boolean;
Begin
 If CheckParOuv(GetInstr) And InstrToBool(GetInstr,b) And
    CheckParFer(GetInstr) Then
  Begin
   Dest.Tp := VR_BOOL;
   Dest.Bl := ExcludeMode;
   ExcludeMode := b;
  End;
End;


{ ExcludeLine(byte) }

Procedure Funct_EXCLUDELINE( Var Dest : VarRec );
Var y : Byte;
Begin
 If CheckParOuv(GetInstr) And InstrToByte(GetInstr,y) And
    CheckParFer(GetInstr) Then
  Begin
   ExcludeLine(y);
  End;
End;


{ ExcludeAll }

Procedure Funct_EXCLUDEALL( Var Dest : VarRec );
Begin
 ExcludeAll;
End;


Function  ExecFunct( n : Word; Var v : VarRec ) : Boolean; Far;
Begin
 v.Tp := VR_WORD;    { Par dfaut }
 v.Wr := 0;

 Case FunctRef(n) Of
  FR_SEND           : Funct_SEND( v );
  FR_WAITOUTEMPTY   : Funct_WAITOUTEMPTY( v );
  FR_SETTIMEOUT     : Funct_SETTIMEOUT( v );
  FR_WAITFLOW       : Funct_WAITFLOW( v );
  FR_WAITFLOWSTR    : Funct_WAITFLOWSTR( v );
  FR_ONLINE         : Funct_ONLINE( v );
  FR_WAITSILENCE    : Funct_WAITSILENCE( v );
  FR_WAITXDATAS     : Funct_WAITXDATAS( v );
  FR_RECEIVESTR     : Funct_RECEIVESTR( v );
  FR_GETSTRXY       : Funct_GETSTRXY( v );
  FR_GETC18         : Funct_GETC18( v );
  FR_COMCLEAR       : Funct_COMCLEAR( v );
  FR_CHECKSTRXY     : Funct_CHECKSTRXY( v );
  FR_CHECKXY        : Funct_CHECKXY( v );
  FR_WAITXY         : Funct_WAITXY( v );
  FR_ENVOI          : Com.Write(#19'A');
  FR_RETOUR         : Com.Write(#19'B');
  FR_REPETITION     : Com.Write(#19'C');
  FR_GUIDE          : Com.Write(#19'D');
  FR_ANNULATION     : Com.Write(#19'E');
  FR_SOMMAIRE       : Com.Write(#19'F');
  FR_CORRECTION     : Com.Write(#19'G');
  FR_SUITE          : Com.Write(#19'H');
  FR_CNXFIN         : Com.Write(#19'I');
  FR_EXCLUDEMODE    : Funct_ExcludeMode( v );
  FR_EXCLUDELINE    : Funct_ExcludeLine( v );
  FR_EXCLUDEALL     : Funct_ExcludeAll( v );
 Else SetError(E_BOGUE);
 End;

 If BreakDetect Then SetError(E_BREAK);

 ExecFunct := TRUE;   { indique seulement que c'est trait... }
End;


Procedure CapTlxInit;
Begin
 TimeOut := 10*1000;    { Init ... }
 ExcludeMode := TRUE;
 FastSend := FALSE;
End;
